/***************************************************************************
 Copyright (c) 1998-2006 Novell, Inc.  All Rights Reserved.

 THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
 TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE 
 LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
 THAT CONTAINS THIS WORK.

 Pursuant to the SDK License Agreement, Novell hereby grants to 
 Developer a royalty-free, non-exclusive license to include the
 sample code derivative binaries in its product.
 Novell grants to Developer worldwide distribution rights to market,
 distribute or sell the sample code and derivative
 binaries as a component of Developer's product(s).  Novell shall 
 have no obligations to Developer or Developer's customers with 
 respect to this code.

DISCLAIMER:

   Novell, Inc. makes no representations or warranties with respect
to the contents or use of this code, and specifically disclaims any
express or implied warranties of merchantability or fitness for any
particular purpose.  Further, Novell, Inc. reserves the right to revise
this publication and to make changes to its content, at any time,
without obligation to notify any person or entity of such revisions or
changes.

   Further, Novell, Inc. makes no representations or warranties with
respect to any software, and specifically disclaims any express or
implied warranties of merchantability or fitness for any particular
purpose.  Further, Novell, Inc. reserves the right to make changes to
any and all parts of the software, at any time, without obligation to
notify any person or entity of such changes.                          

***************************************************************************/

#ifndef __PKIERR_H
#define __PKIERR_H

#define PKI_SUCCESS										0
#define PKI_E_FILE_CREATE								0xFFFFFB4F /* -1201 */
#define PKI_E_FILE_OPEN									0xFFFFFB4E /* -1202 */
#define PKI_E_FILE_READ									0xFFFFFB4D /* -1203 */
#define PKI_E_FILE_WRITE								0xFFFFFB4C /* -1204 */
#define PKI_E_FILE_SEEK									0xFFFFFB4B /* -1205 */
#define PKI_E_CRYPT_INIT								0xFFFFFB4A /* -1206 */
#define PKI_E_NO_KEY_FILE								0xFFFFFB49 /* -1207 */
#define PKI_E_GENERATE_KEY								0xFFFFFB48 /* -1208 */
#define PKI_E_KEY_SIZE_NOT_SUPPORTED				0xFFFFFB47 /* -1209 */
#define PKI_E_KEYS_ALREADY_EXIST						0xFFFFFB46 /* -1210 */
#define PKI_E_UPDATE_KMO								0xFFFFFB45 /* -1211 */
#define PKI_E_INSUFFICIENT_MEMORY					0xFFFFFB44 /* -1212 */
#define PKI_E_BUFFER_OVERFLOW							0xFFFFFB43 /* -1213 */
#define PKI_E_BAD_REQUEST_SYNTAX						0xFFFFFB42 /* -1214 */
#define PKI_E_DSIO										0xFFFFFB41 /* -1215 */
#define PKI_E_CREATE_CERTIFICATE_OR_CSR			0xFFFFFB40 /* -1216 */
#define PKI_E_ALGORITHM_NOT_SUPPORTED				0xFFFFFB3F /* -1217 */
#define PKI_E_UNKNOWN_ATTRIBUTE						0xFFFFFB3E /* -1218 */
#define PKI_E_INVALID_NAME								0xFFFFFB3D /* -1219 */
#define PKI_E_INVALID_CREATE_CA_REQUEST			0xFFFFFB3C /* -1220 */
#define PKI_E_INVALID_OBJECT							0xFFFFFB3B /* -1221 */
#define PKI_E_NOT_SUPPORTED							0xFFFFFB3A /* -1222 */
#define PKI_E_ADD_TRUSTED_ROOT						0xFFFFFB39 /* -1223 */
#define PKI_E_ADD_KEYPAIR								0xFFFFFB38 /* -1224 */
#define PKI_E_ADD_CERTIFICATE							0xFFFFFB37 /* -1225 */
#define PKI_E_EXPECTING_CERTIFICATE					0xFFFFFB36 /* -1226 */
#define PKI_E_BROKEN_CHAIN								0xFFFFFB35 /* -1227 */
#define PKI_E_INIT_ERROR								0xFFFFFB34 /* -1228 */
#define PKI_E_WRONG_VERSION							0xFFFFFB33 /* -1229 */
#define PKI_E_ONLY_ONE_TREE_CA						0xFFFFFB32 /* -1230 */
#define PKI_E_BAD_ROOT_INDEX							0xFFFFFB31 /* -1231 */
#define PKI_E_SUBJECT_NAME_COMPARISON_FAILURE	0xFFFFFB30 /* -1232 */
#define PKI_E_PUBLIC_KEY_COMPARISON_FAILURE		0xFFFFFB2F /* -1233 */
#define PKI_E_NO_RIGHTS									0xFFFFFB2E /* -1234 */
#define PKI_TERISA_ESTABLISH_CONTEXT_ERROR		0xFFFFFB2D /* -1235 */
#define PKI_TERISA_ADD_ROOT_ERROR					0xFFFFFB2C /* -1236 */
#define PKI_TERISA_ADD_KEYS_ERROR					0xFFFFFB2B /* -1237 */
#define PKI_TERISA_ADD_CERTIFICATE_ERROR			0xFFFFFB2A /* -1238 */
#define PKI_E_SYSTEM_RESOURCES						0xFFFFFB29 /* -1239 */
#define PKI_E_PARSE_CERTIFICATE						0xFFFFFB28 /* -1240 */
#define PKI_E_NO_TREE_CA								0xFFFFFB27 /* -1241 */
#define PKI_E_INVALID_NICKNAME  						0xFFFFFB26 /* -1242 */
#define PKI_E_USER_ALREADY_IN_LIST					0xFFFFFB25 /* -1243 */
#define PKI_E_USER_NOT_FOUND_IN_LIST				0xFFFFFB24 /* -1244 */
#define PKI_E_USER_CERT_NOT_FOUND					0xFFFFFB22 /* -1246 */
#define PKI_E_INVALID_ALGORITHM						0xFFFFFB21 /* -1247 */
#define PKI_E_INVALID_OPERATION						0xFFFFFB20 /* -1248 */
#define PKI_E_INVALID_DIGEST							0xFFFFFB1F /* -1249 */
#define PKI_E_DATA_NOT_READY							0xFFFFFB1D /* -1251 */
#define PKI_E_INVALID_KDK_ID							0xFFFFFB1C /* -1252 */
#define PKI_E_INTERNAL_ERROR							0xFFFFFB1B /* -1253 */
#define PKI_E_INVALID_CERTIFICATE_TIME				0xFFFFFB1A /* -1254 */
#define PKI_E_EXPIRED_CERTIFICATE					0xFFFFFB19 /* -1255 */
#define PKI_E_INVALID_SIGNATURE						0xFFFFFB18 /* -1256 */
#define PKI_E_KDK_TABLE_FULL							0xFFFFFB17 /* -1257 */
#define PKI_E_CERT_INVALID								0xFFFFFB16 /* -1258 */
#define PKI_E_CA_ALREADY_INSTALLED					0xFFFFFB15 /* -1259 */
#define PKI_E_CA_NOT_OPERATIONAL						0xFFFFFB14 /* -1260 */
#define PKI_E_KEY_FAILURE								0xFFFFFB13 /* -1261 */
#define PKI_E_INVALID_KEY_ID	 						0xFFFFFB12 /* -1262 */
#define PKI_E_ACCESS_DENIED  							0xFFFFFB11 /* -1263 */
#define PKI_E_NICI_OUTOF_SYNC							0xFFFFFB10 /* -1264 */
#define PKI_E_NO_SECURITY_CONTAINER					0xFFFFFB0F /* -1265 */
#define PKI_E_NO_IP_ADDRESSES							0xFFFFFB0E /* -1266 */
#define PKI_E_NICKNAME_IN_USE							0xFFFFFB0D /* -1267 */
#define PKI_E_NOT_CONNECTED_TO_SERVICE				0xFFFFFB0C /* -1268 */
#define PKI_E_DUPLICATE									0xFFFFFB0B /* -1269 */
#define PKI_E_CRL_INVALID								0xFFFFFB0A /* -1270 */
#define PKI_E_CERT_NOT_FOUND							0xFFFFFB09 /* -1271 */
#define PKI_E_INVALID_CONTEXT							0xFFFFFB08 /* -1272 */
#define PKI_E_SERVICE_NOT_AVAILABLE					0xFFFFFB07 /* -1273 */
#define PKI_E_PARSE_CSR									0xFFFFFB06 /* -1274 */

#endif
