/***************************************************************************

  Copyright (c) 2004-2006 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.
  
 *	File:		NPKI_VER.h
 *
 *	Description:	Novell Certificate Server Version APIs
 ***************************************************************************/

#ifndef   _NPKI_VER_H_
#define   _NPKI_VER_H_

#if defined(__cplusplus)
extern "C" {
#endif

/* Certificate Server and Certificate Server API Versions */
#define PKIS_VERSION_ONE_ZERO_ZERO   			0x00010000	// Major Ver 1 Minor Ver 00
#define PKIS_VERSION_ONE_ZERO_FIVE   			0x00010005	// Major Ver 2 Minor Ver 05
#define PKIS_VERSION_ONE_ZERO_NINE   			0x00010009	// Major Ver 1 Minor Ver 09
#define PKIS_VERSION_TWO_ZERO_ZERO   			0x00020000	// Major Ver 2 Minor Ver 00
#define PKIS_VERSION_TWO_ZERO_TWO				0x00020002	// Major Ver 2 Minor Ver 02
#define PKIS_VERSION_TWO_ZERO_THREE				0x00020003	// Major Ver 2 Minor Ver 03
#define PKIS_VERSION_TWO_ONE_ONE					0x00020011	// Major Ver 2 Minor Ver 11
#define PKIS_VERSION_TWO_TWO_ZERO				0x00020200	// Major Ver 2 Minor Ver 20
#define PKIS_VERSION_TWO_TWO_ONE	   			0x00020201	// Major Ver 2 Minor Ver 21
#define PKIS_VERSION_TWO_FOUR_ZERO	   		0x00020400	// Major Ver 2 Minor Ver 40
#define PKIS_VERSION_TWO_FIVE_ZERO	   		0x00020500	// Major Ver 2 Minor Ver 50
#define PKIS_VERSION_TWO_FIVE_TWO	   		0x00020502	// Major Ver 2 Minor Ver 52
#define PKIS_VERSION_TWO_FIVE_FOUR	   		0x00020504	// Major Ver 2 Minor Ver 54
#define PKIS_VERSION_TWO_SIX_ZERO	   		0x00020600	// Major Ver 2 Minor Ver 60
#define PKIS_VERSION_TWO_SEVEN_ZERO	   		0x00020700	// Major Ver 2 Minor Ver 70
#define PKIS_VERSION_TWO_SEVEN_TWO	   		0x00020702	// Major Ver 2 Minor Ver 72
#define PKIS_VERSION_TWO_SEVEN_THREE   		0x00020703	// Major Ver 2 Minor Ver 73
#define PKIS_VERSION_TWO_SEVEN_FOUR	   		0x00020704	// Major Ver 2 Minor Ver 74
#define PKIS_VERSION_TWO_SEVEN_FIVE	   		0x00020705	// Major Ver 2 Minor Ver 75
#define PKIS_VERSION_TWO_SEVEN_SIX	   		0x00020706	// Major Ver 2 Minor Ver 76
#define PKIS_VERSION_TWO_SEVEN_SEVEN   		0x00020707	// Major Ver 2 Minor Ver 77
#define PKIS_VERSION_TWO_SEVEN_EIGHT   		0x00020708	// Major Ver 2 Minor Ver 78
#define PKIS_VERSION_TWO_SEVEN_NINE				0x00020709	// Major Ver 2 Minor Ver 79
#define PKIS_VERSION_THREE_ZERO_ZERO   		0x00030000	// Major Ver 3 Minor Ver 00
#define PKIS_VERSION_THREE_ONE_ZERO				0x00030100	// Major Ver 3 Minor Ver 10
#define PKIS_VERSION_THREE_ONE_ONE				0x00030101	// Major Ver 3 Minor Ver 11
#define PKIS_VERSION_THREE_TWO_ZERO				0x00030200	// Major Ver 3 Minor Ver 20
#define PKIS_VERSION_THREE_TWO_ONE				0x00030201	// Major Ver 3 Minor Ver 21
#define PKIS_VERSION_THREE_TWO_TWO				0x00030202	// Major Ver 3 Minor Ver 22
#define PKIS_VERSION_THREE_THREE_ZERO			0x00030300	// Major Ver 3 Minor Ver 30

#define NPKIT_VERSION								PKIS_VERSION_THREE_THREE_ZERO
#define NPKI_VERSION									PKIS_VERSION_THREE_THREE_ZERO
#define NPKI_CERTIFICATE_SERVER_VERSION		PKIS_VERSION_THREE_THREE_ZERO
#define NPKI_INSTALL_VERSION						PKIS_VERSION_THREE_THREE_ZERO

#define PKIS_CURRENT_VERSION_STRING	   		"3.30"

#if defined(__cplusplus)
}
#endif
#endif    /*   _NPKI_VER_H_  */
